tests: allow multiple lines in argument files
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22
23 # The default nitc compiler
24 [ -z "$NITC" ] && NITC=../bin/nitc
25
26 usage()
27 {
28 e=`basename "$0"`
29 cat<<END
30 Usage: $e [options] modulenames
31 -o option Pass option to nitc
32 -v Verbose (show tests steps)
33 -h This help
34 END
35 }
36
37 # As argument: the pattern used for the file
38 function process_result()
39 {
40 # Result
41 pattern=$1
42 SAV=""
43 FAIL=""
44 if [ -r "sav/$pattern.sav" ]; then
45 diff -u "$pattern.res" "sav/$pattern.sav" > "$pattern.diff.sav.log"
46 if [ "$?" == 0 ]; then
47 SAV=OK
48 else
49 SAV=NOK
50 fi
51 fi
52 if [ -r "sav/$pattern.fail" ]; then
53 diff -u "$pattern.res" "sav/$pattern.fail" > "$pattern.diff.fail.log"
54 if [ "$?" == 0 ]; then
55 FAIL=OK
56 else
57 FAIL=NOK
58 fi
59 fi
60 if [ "x$SAV" = "xOK" ]; then
61 if [ "x$FAIL" = "x" ]; then
62 echo "[ok] $pattern.res"
63 else
64 echo "[ok] $pattern.res - but sav/$pattern.fail remains!"
65 fi
66 ok="$ok $pattern"
67 elif [ "x$FAIL" = "xOK" ]; then
68 echo "[fail] $pattern.res"
69 ok="$ok $pattern"
70 elif [ "x$SAV" = "xNOK" ]; then
71 echo "[======= fail $pattern.res sav/$pattern.sav =======]"
72 nok="$nok $ff"
73 echo "$ii" >> "$ERRLIST"
74 elif [ "x$FAIL" = "xNOK" ]; then
75 echo "[======= changed $pattern.res sav/$pattern.fail ======]"
76 nok="$nok $ff"
77 echo "$ii" >> "$ERRLIST"
78 else
79 echo "[=== no sav ===] $pattern.res"
80 nos="$nos $pattern"
81 fi
82 }
83
84
85 verbose=false
86 stop=false
87 while [ $stop = false ]; do
88 case $1 in
89 -o) OPT="$OPT $2"; shift; shift;;
90 -v) verbose=true; shift;;
91 -h) usage; exit;;
92 *) stop=true
93 esac
94 done
95
96 # Mark to distinguish files among tests
97 # MARK=
98
99 # File where error tests are outputed
100 # Old ERRLIST is backuped
101 ERRLIST=${ERRLIST:-errlist}
102
103 if [ $# = 0 ]; then
104 usage;
105 exit
106 fi
107
108 # Backup and initiate new ERRLIST
109 if [ "x$ERRLIST" = "x" ]; then
110 ERRLIST=/dev=null
111 else
112 if [ -x "$ERRLIST" ]; then
113 mv "$ERRLIST" "${ERRLIST}.bak"
114 fi
115 > "$ERRLIST"
116 fi
117
118 ok=""
119 nok=""
120
121 for ii in "$@"; do
122 for alt in "" `sed -n 's/.*#!*\(alt[0-9]*\)#.*/\1/p' "$ii" | sort -u`; do
123 f=`basename "$ii" .nit`
124 d=`dirname "$ii"`
125 ff="$f"
126 i="$ii"
127 if [ "x$alt" != "x" ]; then
128 test -d alt || mkdir -p alt
129 i="alt/${f}_$alt.nit"
130 ff="${ff}_$alt"
131 sed "s/#$alt#//g;/#!$alt#/d" "$ii" > "$i"
132 fi
133 ff="$ff$MARK"
134
135 echo -n "=> $i: "
136
137 rm "$ff.res" "$ff.err" "$ff.write" "$ff.bin" 2> /dev/null
138
139 # Compile
140 if [ "x$verbose" = "xtrue" ]; then
141 echo ""
142 echo $NITC $OPT -o "$ff.bin" "$i" -I . -I alt -I ../lib/standard
143 fi
144 $NITC $OPT -o "$ff.bin" "$i" -I . -I alt -I ../lib/standard 2> "$ff.cmp.err" > "$ff.compile.log"
145 ERR=$?
146 if [ "x$verbose" = "xtrue" ]; then
147 cat "$ff.compile.log"
148 cat >&2 "$ff.cmp.err"
149 fi
150 egrep '^[A-Z0-9_]*$' "$ff.compile.log" > "$ff.res"
151 if [ "$ERR" != 0 ]; then
152 echo -n "! "
153 cp "$ff.cmp.err" "$ff.res"
154 process_result $ff
155 elif [ -x "./$ff.bin" ]; then
156 echo -n ". "
157 # Execute
158 args=""
159 if [ "x$verbose" = "xtrue" ]; then
160 echo ""
161 echo "./$ff.bin" $args
162 fi
163 if [ -f "$f.inputs" ]; then
164 "./$ff.bin" $args < "$f.inputs" > "$ff.res" 2>"$ff.err"
165 else
166 "./$ff.bin" $args > "$ff.res" 2>"$ff.err"
167 fi
168 if [ "x$verbose" = "xtrue" ]; then
169 cat "$ff.res"
170 cat >&2 "$ff.err"
171 fi
172 if [ -f "$ff.write" ]; then
173 cat "$ff.write" >> "$ff.res"
174 fi
175 if [ -s "$ff.err" ]; then
176 cat "$ff.err" >> "$ff.res"
177 fi
178 process_result $ff
179
180 if [ -f "$f.args" ]; then
181 fargs=$f.args
182 cptr=0
183 cat $fargs |
184 while read line; do
185 ((cptr=cptr+1))
186 args=$line
187 fff=$ff"_args"$cptr
188 if [ "x$verbose" = "xtrue" ]; then
189 echo ""
190 echo "./$ff.bin" $args
191 fi
192 echo -n "==> args #"$cptr " "
193 if [ -f "$f.inputs" ]; then
194 "./$ff.bin" $args < "$f.inputs" > "$fff.res" 2>"$fff.err"
195 else
196 sh -c "./$ff.bin ''$args > $fff.res 2>$fff.err"
197 fi
198 if [ "x$verbose" = "xtrue" ]; then
199 cat "$fff.res"
200 cat >&2 "$fff.err"
201 fi
202 if [ -f "$fff.write" ]; then
203 cat "$fff.write" >> "$fff.res"
204 fi
205 if [ -s "$fff.err" ]; then
206 cat "$fff.err" >> "$fff.res"
207 fi
208 process_result $fff
209 done
210 fi
211 else
212 echo -n "! "
213 echo "Compilation error" > "$ff.res"
214 process_result $ff
215 fi
216 done
217 done
218
219 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos | wc -w`
220
221 if [ -n "$nok" ]; then
222 echo "fail: $nok"
223 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
224 fi
225 if [ -n "$nos" ]; then
226 echo "no sav: $nos"
227 fi
228
229 if [ -n "$nok" ]; then
230 exit 1
231 else
232 exit 0
233 fi